Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 456360 - kde-base/print-manager looking for org.fedoraproject.Config.Printing
Summary: kde-base/print-manager looking for org.fedoraproject.Config.Printing
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] KDE (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Maciej Mrozowski
URL: https://bugs.kde.org/show_bug.cgi?id=...
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-02-10 00:22 UTC by Kirill Elagin
Modified: 2015-01-10 11:05 UTC (History)
13 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge --info (emerge-info,17.00 KB, text/plain)
2013-02-10 00:25 UTC, Kirill Elagin
Details
system-config-printer-common-1.4.3-r1-split.patch (system-config-printer-common-1.4.3-r1-split.patch,4.86 KB, patch)
2013-12-01 11:14 UTC, Andreas Sturmlechner
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Kirill Elagin 2013-02-10 00:22:06 UTC
I'm trying to add a printer, published via dns-sd (by printserver running CUPS+Avahi).

When I run print-manager, and click “New printer”, my printer is discovered, but there is a red error “The name org.fedoraproject.Config.Printing was not provided by any .service files”. If I close the window and open it again, the printer is discovered and this error is displayed sometimes, and sometimes there is no error and no printer. It seems to be a bit random for now…
Comment 1 Kirill Elagin 2013-02-10 00:25:14 UTC
Created attachment 338448 [details]
emerge --info

This brand new emerge --info is so awesome it won't fit in the comment field.
Comment 2 Ian Whyman (thev00d00) gentoo-dev 2013-02-14 21:31:30 UTC
Strangely this is provided by app-admin/system-config-printer-gnome
Comment 3 Andreas K. Hüttel archtester gentoo-dev 2013-05-26 19:39:57 UTC
Which print-manager version was that? Do you still have the problem with 4.10.3?
Comment 4 Kirill Elagin 2013-05-26 19:58:57 UTC
(In reply to Andreas K. Hüttel from comment #3)
> Which print-manager version was that?
I have no idea. Which was the latest unstable at the time the bug was created?

Just tried with 4.10.3. The error now looks more beautiful and appears _every time_, not randomly.
Comment 5 Kirill Elagin 2013-05-26 20:00:43 UTC
(I should probably note that, obviously, I removed app-admin/system-config-printer-gnome before trying. The error disappeared when I reinstalled it.)
Comment 6 Andreas Sturmlechner gentoo-dev 2013-06-09 09:03:47 UTC
Same here with KDE SC 4.10.4.

Without system-config-printer-gnome, I always get the error message when adding a printer, but my network printer is well discovered.

Having system-config-printer-gnome emerged, the error message is gone, but gone as well is the list of discovered printers.
Comment 7 Andreas Sturmlechner gentoo-dev 2013-06-09 09:09:42 UTC
I just forgot to restart dbus. Done that, and the printer is discovered now.
Comment 8 Andreas K. Hüttel archtester gentoo-dev 2013-06-09 09:15:47 UTC
added runtime dependency on app-admin/system-config-printer-gnome
(this does not pull in any gnome packages usually, don't worry)
Comment 9 Nikoli 2013-06-09 12:36:32 UTC
system-config-printer dep is indeed required:
print-manager-4.10.3 $ grep -Ri org.fedoraproject.Config.Printing|wc -l
9

But having app-admin/system-config-printer-gnome in RDEPEND is ugly: it wants old and obsolete pygtk.

Why /usr/share/dbus-1/interfaces/org.fedoraproject.Config.Printing.xml
and related files are not in system-config-printer-common package? Having them in system-config-printer-gnome is pointless.

system-config-printer-* packages should be fixed and dep changed to app-admin/system-config-printer-common

Even ubuntu has it done much better:
http://packages.ubuntu.com/raring/system-config-printer-common
http://packages.ubuntu.com/raring/system-config-printer-udev
http://packages.ubuntu.com/raring/system-config-printer-gnome
Comment 10 Maciej Mrozowski gentoo-dev 2013-06-09 13:25:07 UTC
Reopening and reassigning. Dependency on scp-gnome is not the way to go. I'' consider splitting rearrangig stuff in scp (maybe create separate ebuild for dbus interface) once I know what print-manager actually needs...
Comment 11 Jouni Rinne 2013-08-12 17:10:42 UTC
This should be resolved fast, because the new system-config-printer-gnome-1.4.1 has quite a huge amount of gnome/gtk3 dependencies. /me going to mask 1.4.1 until fixed.
Comment 12 Andreas Sturmlechner gentoo-dev 2013-12-01 11:01:33 UTC
I've tried to split scp like they do in Ubuntu, but in 1.4.3 the following line has appeared in scp-dbus-service.py, which gets called by print-manager when searching for printers:

from gi.repository import Gdk


So I'm currently stuck here:

ERROR:root:Could not find any typelib for Gdk
Traceback (most recent call last):
  File "/usr/share/system-config-printer/scp-dbus-service.py", line 26, in <module>
    from gi.repository import Gdk
ImportError: cannot import name Gdk


A dependency on x11-libs/gdk-pixbuf[introspection] didn't help, so maybe gtk+:3 is needed here for whatever reason...
Comment 13 Andreas Sturmlechner gentoo-dev 2013-12-01 11:14:39 UTC
Created attachment 364324 [details, diff]
system-config-printer-common-1.4.3-r1-split.patch

keep more stuff in -common for use with kde-base/print-manager
Comment 14 Andreas Sturmlechner gentoo-dev 2013-12-01 12:54:22 UTC
Removed the Gdk calls, but then further down the code in scp-dbus-service.py they import jobviewer.py, which itself depends on gtk, pango etc. again. I had removed jobviewer.py in the 1.4.3-r1-split.patch as seen from the files list of Ubuntu, but that means they must have a circular dep scp-common <-> scp-gnome...

It seems to me a sane split where print-manager can really depend just on scp-common is not possible without serious code mangling.
Comment 15 kavol 2014-03-21 16:33:24 UTC
I'm pretty confused ... seems that I'm missing something, can someone explain why
kde-base/kdeutils-meta has a dependency chain that explicitly blocks kde-base/system-config-printer-kde and depends on app-admin/system-config-printer-gnome instead?

I could find some clue in comment #12 that printer-manager depends on that -gnome thing, but why don't we go with the -kde thing in the first place?
Comment 16 Kirill Elagin 2014-03-21 19:41:26 UTC
(In reply to kavol from comment #15)
> kde-base/system-config-printer-kde and depends on

Where did you find kde-base/system-config-printer-kde?
There is no such ebuild in the portage tree right now as system-config-printer-kde has been deprecated some time ago in favour of kde-base/print-manager.
Comment 17 kavol 2014-03-22 07:57:53 UTC
(In reply to Kirill Elagin from comment #16)
> (In reply to kavol from comment #15)
> > kde-base/system-config-printer-kde and depends on
> 
> Where did you find kde-base/system-config-printer-kde?

um ... /usr/portage/kde-base/print-manager/print-manager-4.12.3.ebuild

RDEPEND="${DEPEND}
        !kde-base/printer-applet:4
        !kde-base/system-config-printer-kde:4
        !kde-misc/print-manager
        app-admin/system-config-printer-gnome
"

> There is no such ebuild in the portage tree right now

I haven't gone so far in investigation, sorry, my overlook

> as system-config-printer-kde has been deprecated some time ago in favour of
> kde-base/print-manager.

don't know the reasons behind the change, but IMO, better to deprecate without replacement than to replace with GNOME stuff - those who want it can install it explicitly, and those who want to save resources (like me :-)) are not exactly happy finding out that tons of irrelevant stuff had sneaked in as dependencies of what is supposed to have nothing with that stuff ...
Comment 18 Kirill Elagin 2014-03-22 08:32:09 UTC
(In reply to kavol from comment #17)
> don't know the reasons behind the change, but IMO, better to deprecate
> without replacement than to replace with GNOME stuff - those who want it can
> install it explicitly, and those who want to save resources (like me :-))
> are not exactly happy finding out that tons of irrelevant stuff had sneaked
> in as dependencies of what is supposed to have nothing with that stuff ...

I agree.
It was not the case until recently that system-config-printer-gnome pulled Gnome stuff. Seems that something has changed recently, unfortunately.
Comment 19 Maciej Mrozowski gentoo-dev 2014-04-27 23:10:27 UTC
To me this is really upstream bug - print-manager not handling scp (optional runtime dependency) gracefully/predictably.
Comment 20 Kirill Elagin 2014-04-28 07:23:16 UTC
I think it's been handling it predictably for a while now (see comment #4).
And anyway, they claim it to be scp bug.
Comment 21 Pacho Ramos gentoo-dev 2014-10-18 17:50:09 UTC
What gnome stuff is people trying to avoid here? scp has "gnome" name but I only see this dependencies there:
        ${PYTHON_DEPS}
        ~app-admin/system-config-printer-common-${PV}
        dev-python/pycairo[${PYTHON_USEDEP}]
        >=dev-python/pycups-1.9.60[${PYTHON_USEDEP}]
        dev-python/pygobject:3[${PYTHON_USEDEP}]
        x11-libs/gtk+:3[introspection]
        x11-libs/libnotify[introspection]
        x11-libs/pango[introspection]
        gnome-keyring? ( gnome-base/libgnome-keyring[introspection] )


Then... all this splitting (that causes us to be slower to bump scp as we are the only distribution doing that splitting and are a bit alone for that then) is for avoiding gtk+:3 dep? (because, seriously, people should really really try to use pygobject:3 instead of the completely dead and semi-broken :2 slot)
Comment 22 Pacho Ramos gentoo-dev 2014-10-18 17:51:10 UTC
Well, even the KDE upstream doesn't agree with this splitting:
https://bugs.kde.org/show_bug.cgi?id=320326

:|
Comment 23 Luke-Jr 2014-10-18 17:53:12 UTC
Personally, my preference is to hard-mask dev-libs/glib (locally, of course).
Comment 24 Andreas Sturmlechner gentoo-dev 2014-10-18 18:28:03 UTC
(In reply to Pacho Ramos from comment #22)
> Well, even the KDE upstream doesn't agree with this splitting:
> https://bugs.kde.org/show_bug.cgi?id=320326
> 
> :|

The splitting does not really work, and at the same time upstream says s-c-p is not really mandatory. So, I would opt for

1) get rid of it
2) make it an optional dep in print-manager (what USE-flag then?)
3) call for a more descriptive _warning_ instead of that useless _error_ message, after all, I can add my printer just fine in print-manager without having s-c-p installed, only without the helping hand wrt device grouping
Comment 25 Maciej Mrozowski gentoo-dev 2014-10-20 20:05:59 UTC
+1 from me.
Comment 26 Michael Palimaka (kensington) gentoo-dev 2014-11-24 17:22:18 UTC
We hide the dependency behind gtk USE flag lately, so I guess we're done.